﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;
using Tanshu.Accounts.Repository;
using Tanshu.Accounts.Contracts;

namespace Tanshu.Accounts.PointOfSale
{
    public partial class DiscountReportForm : Form
    {
        IList<SalesAnalysis> _list;
        public DiscountReportForm()
        {
            InitializeComponent();
        }

        private void dtpStart_ValueChanged(object sender, EventArgs e)
        {
            ShowStatement();
        }

        private void ShowStatement()
        {
            if (DateTime.Today.Subtract(dtpStart.Value.Date).Days > 5 && !Session.IsAllowed("Accounts Audit"))
                return;
            _list = ReportsBI.DiscountReport(dtpStart.Value, dtpFinish.Value);
            dgvSale.AutoGenerateColumns = true;
            dgvSale.DataSource = _list;
            dgvSale.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.AllCells;
            dgvSale.Columns[1].DefaultCellStyle.Format = "#,##0.00;(#,##0.00);0";
            dgvSale.Columns[1].DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight;
        }

        private void dtpFinish_ValueChanged(object sender, EventArgs e)
        {
            ShowStatement();
        }

        private void DiscountReportForm_Load(object sender, EventArgs e)
        {
            dtpStart.Value = DateTime.Today;
            dtpFinish.Value = DateTime.Today;
            ShowStatement();
        }
    }
}
