﻿using System;
using System.Drawing;
using System.Windows.Forms;
using Tanshu.Accounts.Contracts;
using Tanshu.Accounts.Repository;
using Tanshu.Common.KeyboardControl;

namespace Tanshu.Accounts.PointOfSale
{
    public partial class ChangePassword : Form
    {
        IKeyboardControl keyboardControl;
        public ChangePassword(IKeyboardControl keyboardControl)
        {
            InitializeComponent();
            this.keyboardControl = keyboardControl;

            var control = keyboardControl as UserControl;
            if (control != null)
            {
                control.Location = new System.Drawing.Point(6, 140);
                this.Controls.Add(control);
                this.Size = this.SizeFromClientSize(new Size(6 + control.Width + 6, 140 + control.Height + 6));
            }

        }

        private void ChangePassword_Load(object sender, EventArgs e)
        {
            txtUsername.Text = Session.User.Name;
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void btnChangePassword_Click(object sender, EventArgs e)
        {
            if (txtPassword.Text.Trim() == "")
                MessageBox.Show("Old password can not be blank", "Blank not allowed");
            else
            {
                if (txtnewPassword.Text.Trim() == "")
                    MessageBox.Show("New password can not be blank", "Blank not allowed");
                else
                {
                    if (txtnewPassword.Text.Trim() != txtConfirmPassword.Text.Trim())
                        MessageBox.Show("New password not matched to confirm password", "Password not matched");
                    else
                    {
                        var changed = UserBI.ChangePassword(Session.User.Name, txtPassword.Text.Trim(), txtnewPassword.Text.Trim());
                        if (changed)
                        {
                                MessageBox.Show("Password changed", "Confirm");
                                this.Close();
                        }
                        else
                            MessageBox.Show("old Password not matched for user", "Wrong Password");
                    }
                }
            }
        }


        private void btnMsr_Click(object sender, EventArgs e)
        {
            var user = UserBI.ValidateUser(Session.User.Name, txtPassword.Text.Trim());
            if (user == null)
                return;
            using (var frm = new MsrLoginForm(true))
            {
                frm.ShowDialog();
                var msrString = frm.User().MsrString;
                if (MessageBox.Show("Update Msr Card", "Update", MessageBoxButtons.YesNo, MessageBoxIcon.Question) !=
                    DialogResult.Yes)
                    return;
                UserBI.ChangeMsr(user.Name, txtPassword.Text.Trim(), msrString);
                MessageBox.Show("Msr Card Updated");
                this.Close();
            }
        }
    }
}
