﻿using RestSharp;
using System;
using System.Collections.Generic;
using Tanshu.Accounts.Contracts;

namespace Tanshu.Accounts.Repository
{
    public static class ReportsBI
    {
        public static IList<BeerConsumptionDetail> BeerConsumption(DateTime startDate, DateTime finishDate)
        {
            startDate = startDate.Date.AddHours(6);
            finishDate = finishDate.Date.AddDays(1).AddHours(5);
            if (finishDate <= startDate)
                return new List<BeerConsumptionDetail>();

            var request = new RestRequest();
            request.Resource = "BeerConsumption.json";
            request.AddQueryParameter("s", startDate.ToString("dd-MMM-yyyy HH:mm"));
            request.AddQueryParameter("f", finishDate.ToString("dd-MMM-yyyy HH:mm"));
            return JsonStore.Execute<List<BeerConsumptionDetail>>(request);
        }
        public static IList<SalesAnalysisDetail> SaleQuantity(DateTime startDate, DateTime finishDate)
        {
            startDate = startDate.Date.AddHours(6);
            finishDate = finishDate.Date.AddDays(1).AddHours(5);
            if (finishDate <= startDate)
                return new List<SalesAnalysisDetail>();

            var request = new RestRequest();
            request.Resource = "QuantitySold.json";
            request.AddQueryParameter("s", startDate.ToString("dd-MMM-yyyy HH:mm"));
            request.AddQueryParameter("f", finishDate.ToString("dd-MMM-yyyy HH:mm"));
            return JsonStore.Execute<List<SalesAnalysisDetail>>(request);
        }
        public static IList<BillDetail> GetBillDetails(DateTime startDate, DateTime finishDate)
        {
            startDate = startDate.Date.AddHours(6);
            finishDate = finishDate.Date.AddDays(1).AddHours(5);
            if (finishDate <= startDate)
                return new List<BillDetail>();

            var request = new RestRequest();
            request.Resource = "BillDetails.json";
            request.AddQueryParameter("s", startDate.ToString("dd-MMM-yyyy HH:mm"));
            request.AddQueryParameter("f", finishDate.ToString("dd-MMM-yyyy HH:mm"));
            return JsonStore.Execute<List<BillDetail>>(request);
        }
        public static IList<SalesAnalysis> DiscountReport(DateTime startDate, DateTime finishDate)
        {
            startDate = startDate.Date.AddHours(6);
            finishDate = finishDate.Date.AddDays(1).AddHours(5);
            if (finishDate <= startDate)
                return new List<SalesAnalysis>();

            var request = new RestRequest();
            request.Resource = "DiscountReport.json";
            request.AddQueryParameter("s", startDate.ToString("dd-MMM-yyyy HH:mm"));
            request.AddQueryParameter("f", finishDate.ToString("dd-MMM-yyyy HH:mm"));
            return JsonStore.Execute<List<SalesAnalysis>>(request);
        }
        public static IList<BillDetail> VoidOrReprintedBillsList(DateTime startDate, DateTime finishDate)
        {
            startDate = startDate.Date.AddHours(6);
            finishDate = finishDate.Date.AddDays(1).AddHours(5);
            if (finishDate <= startDate)
                return new List<BillDetail>();

            var request = new RestRequest();
            request.Resource = "ReprintReport.json";
            request.AddQueryParameter("s", startDate.ToString("dd-MMM-yyyy HH:mm"));
            request.AddQueryParameter("f", finishDate.ToString("dd-MMM-yyyy HH:mm"));
            return JsonStore.Execute<List<BillDetail>>(request);
        }
    }
}
